Index: src/bin/pg_dump/pg_dump.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/bin/pg_dump/pg_dump.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/bin/pg_dump/pg_dump.c	19 May 2009 06:59:36 -0000	1.1.1.2
--- src/bin/pg_dump/pg_dump.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 1364,1369 ****
--- 1364,1401 ----
  	PQExpBuffer copyBuf = createPQExpBuffer();
  	DataDumperPtr dumpFn;
  	char	   *copyStmt;
+     int ntuples;
+     PGresult   *res;
+ 	PQExpBuffer query = createPQExpBuffer();
+ 	char		*tableName;
+ 
+     /* If a partition, then do nothing. */
+ 	query = createPQExpBuffer();
+     initPQExpBuffer(query);
+     appendPQExpBuffer(query, "SELECT * from public.pg_partitions where child = '%s';", tbinfo->dobj.name);
+     res = PQexec(g_conn, query->data);
+     check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+     ntuples = PQntuples(res);
+ 
+     if(ntuples > 0)
+     {
+         PQclear(res);
+         return;
+     }
+ 
+ 	/* We dont want to dump data of overflow table. */
+ 
+ 	tableName = NULL;
+     initPQExpBuffer(query);
+     appendPQExpBuffer(query, "SELECT public.getparentfromoverflow(%u);", tbinfo->dobj.catId.oid);
+     res = PQexec(g_conn, query->data);
+     check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 	tableName = PQgetvalue(res, 0, 0);
+ 
+ 	if(strlen(tableName))
+ 	{
+ 		return;
+ 	}
  
  	if (!dump_inserts)
  	{
***************
*** 9736,9745 ****
--- 9768,9806 ----
  	}
  	else
  	{
+ 
+ 		int ntuples;
+ 	
+ 	    initPQExpBuffer(query);
+ 	    appendPQExpBuffer(query, "SELECT * from public.pg_partitions where child = '%s';", tbinfo->dobj.name);
+     	res = PQexec(g_conn, query->data);
+ 	    check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 		ntuples = PQntuples(res);
+ 
+ 		/* We dont want to dump schema of partitions. */
+ 		if(ntuples > 0)
+ 		{
+ 			PQclear(res);
+ 			return;
+ 		}
+ 
  		reltypename = "TABLE";
  		numParents = tbinfo->numParents;
  		parents = tbinfo->parents;
  
+ 	    initPQExpBuffer(query);
+ 	    appendPQExpBuffer(query, "SELECT public.isvalidoverflowpartition(%u);", tbinfo->dobj.catId.oid);
+ 		res = PQexec(g_conn, query->data);
+     	check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 
+ 		/* We dont want to dump anything for overflow table except the data. */
+ 		if(atooid(PQgetvalue(res, 0, 0)))
+ 		{
+ 			PQclear(res);
+     		return;
+ 		}
+ 
+ 
  		/*
  		 * DROP must be fully qualified in case same name appears in
  		 * pg_catalog
***************
*** 9860,9865 ****
--- 9921,9935 ----
  			appendPQExpBuffer(q, ")");
  		}
  
+ 		/* Check if we are dumping partitioned table, if so then get the SQL 
+ 		for creating partitioned table. */
+ 
+ 		initPQExpBuffer(query);
+ 		appendPQExpBuffer(query, "SELECT public.dumppartitionedtableschema(%u) as schema", tbinfo->dobj.catId.oid);
+ 		res = PQexec(g_conn, query->data);
+ 		check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 		appendPQExpBuffer(q, PQgetvalue(res, 0, 0));
+ 
  		appendPQExpBuffer(q, ";\n");
  
  		/*
***************
*** 10101,10113 ****
  static void
  dumpIndex(Archive *fout, IndxInfo *indxinfo)
  {
! 	TableInfo  *tbinfo = indxinfo->indextable;
  	PQExpBuffer q;
  	PQExpBuffer delq;
  
  	if (dataOnly)
  		return;
  
  	q = createPQExpBuffer();
  	delq = createPQExpBuffer();
  
--- 10171,10198 ----
  static void
  dumpIndex(Archive *fout, IndxInfo *indxinfo)
  {
! 	TableInfo  	*tbinfo = indxinfo->indextable;
  	PQExpBuffer q;
  	PQExpBuffer delq;
+     PGresult   	*res;
+     PQExpBuffer query = createPQExpBuffer();
+ 
  
  	if (dataOnly)
  		return;
  
+ 	initPQExpBuffer(query);
+ 	appendPQExpBuffer(query, "SELECT public.isoverflowindex(%u);", indxinfo->dobj.catId.oid);
+ 	res = PQexec(g_conn, query->data);
+ 	check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 
+ 	/* We dont want to dump overflow-index. */
+ 	if(atooid(PQgetvalue(res, 0, 0)))
+ 	{
+ 		PQclear(res);
+ 		return;
+ 	}
+ 
  	q = createPQExpBuffer();
  	delq = createPQExpBuffer();
  
***************
*** 10173,10183 ****
--- 10258,10297 ----
  	TableInfo  *tbinfo = coninfo->contable;
  	PQExpBuffer q;
  	PQExpBuffer delq;
+     int ntuples;
+     PGresult   *res;
+     PQExpBuffer query = createPQExpBuffer();
  
  	/* Skip if not to be dumped */
  	if (!coninfo->dobj.dump || dataOnly)
  		return;
  
+     initPQExpBuffer(query);
+     appendPQExpBuffer(query, "SELECT * from public.pg_partitions where child = '%s';", tbinfo->dobj.name);
+     res = PQexec(g_conn, query->data);
+     check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+     ntuples = PQntuples(res);
+ 
+     /* We dont want to dump constraints of partitions. */
+     if(ntuples > 0)
+     {
+         PQclear(res);
+         return;
+     }
+ 
+ 	initPQExpBuffer(query);
+ 	appendPQExpBuffer(query, "SELECT public.isvalidoverflowpartition(%u);", tbinfo->dobj.catId.oid);
+ 	res = PQexec(g_conn, query->data);
+ 	check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 
+ 	/* We dont want to dump anything for overflow table except the data. */
+ 	if(atooid(PQgetvalue(res, 0, 0)))
+ 	{
+ 		PQclear(res);
+ 		return;
+ 	}
+ 
+ 
  	q = createPQExpBuffer();
  	delq = createPQExpBuffer();
  
***************
*** 10708,10720 ****
  dumpTrigger(Archive *fout, TriggerInfo *tginfo)
  {
  	TableInfo  *tbinfo = tginfo->tgtable;
! 	PQExpBuffer query;
  	PQExpBuffer delqry;
  	const char *p;
  	int			findx;
  
  	if (dataOnly)
  		return;
  
  	query = createPQExpBuffer();
  	delqry = createPQExpBuffer();
--- 10822,10878 ----
  dumpTrigger(Archive *fout, TriggerInfo *tginfo)
  {
  	TableInfo  *tbinfo = tginfo->tgtable;
! 	PQExpBuffer query = createPQExpBuffer();
  	PQExpBuffer delqry;
  	const char *p;
  	int			findx;
+ 	int 		ntuples;
+     PGresult   *res;
+ 
  
  	if (dataOnly)
  		return;
+ 
+ 	/* If a partition or partitioned table, then do nothing as triggers would 
+ 	get created automatically with the SQL generated for partitioned tbale.*/
+ 
+ 	initPQExpBuffer(query);
+ 	appendPQExpBuffer(query, "SELECT * from public.pg_partitions where parent = '%s';", tbinfo->dobj.name);
+ 	res = PQexec(g_conn, query->data);
+ 	check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 	ntuples = PQntuples(res);
+ 
+ 	if(ntuples > 0)
+ 	{
+ 		PQclear(res);
+ 		return;
+ 	}
+ 
+     initPQExpBuffer(query);
+     appendPQExpBuffer(query, "SELECT * from public.pg_partitions where child = '%s';", tbinfo->dobj.name);
+     res = PQexec(g_conn, query->data);
+     check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+     ntuples = PQntuples(res);
+ 
+     /* We dont want to dump triggers of partitions. */
+     if(ntuples > 0)
+     {
+         PQclear(res);
+         return;
+     }
+ 
+     initPQExpBuffer(query);
+     appendPQExpBuffer(query, "SELECT public.isvalidoverflowpartition(%u);", tbinfo->dobj.catId.oid);
+     res = PQexec(g_conn, query->data);
+     check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 
+     /* We dont want to dump anything for overflow table except the data. */
+     if(atooid(PQgetvalue(res, 0, 0)))
+     {
+         PQclear(res);
+         return;
+     }
+ 
  
  	query = createPQExpBuffer();
  	delqry = createPQExpBuffer();
Index: src/include/catalog/indexing.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/catalog/indexing.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/include/catalog/indexing.h	19 May 2009 06:59:37 -0000	1.1.1.2
--- src/include/catalog/indexing.h	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 57,62 ****
--- 57,68 ----
   * index name (much less the numeric OID).
   */
  
+ DECLARE_INDEX(pg_partition_primary_index, 2337, on pg_partition using btree(parentrelid oid_ops, partrelid oid_ops, keyorder int2_ops));
+ #define PartitionParentIndexId 2337
+ 
+ DECLARE_UNIQUE_INDEX(pg_partition_oid_index, 2338, on pg_partition using btree(oid oid_ops));
+ #define PartitionOidIndexId 2338
+ 
  DECLARE_UNIQUE_INDEX(pg_aggregate_fnoid_index, 2650, on pg_aggregate using btree(aggfnoid oid_ops));
  #define AggregateFnoidIndexId  2650
  
Index: src/include/catalog/pg_inherits_fn.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/catalog/pg_inherits_fn.h,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.2.1
diff -c -r1.1.1.1 -r1.1.1.1.2.1
*** src/include/catalog/pg_inherits_fn.h	19 May 2009 06:59:37 -0000	1.1.1.1
--- src/include/catalog/pg_inherits_fn.h	8 Jun 2009 08:28:51 -0000	1.1.1.1.2.1
***************
*** 21,25 ****
--- 21,27 ----
  extern List *find_all_inheritors(Oid parentrelId, LOCKMODE lockmode);
  extern bool has_subclass(Oid relationId);
  extern bool typeInheritsFrom(Oid subclassTypeId, Oid superclassTypeId);
+ extern List *find_inheritance_parents(Oid inhchild);
+ extern List *find_all_ancestors(Oid childrel);
  
  #endif   /* PG_INHERITS_FN_H */
Index: src/include/commands/tablecmds.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/commands/tablecmds.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/include/commands/tablecmds.h	19 May 2009 06:59:38 -0000	1.1.1.2
--- src/include/commands/tablecmds.h	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 18,23 ****
--- 18,38 ----
  #include "utils/relcache.h"
  
  
+ typedef struct partitionInfo
+ {
+     char    partitionName[20];
+     Value   minValue;
+     Value   maxValue;
+ }partitionInfo;
+ 
+ enum SpecialPartitionRanges
+ {
+     MINVALRANGE,
+     MAXVALRANGE,
+     OTHER
+ };
+ 
+ 
  extern Oid	DefineRelation(CreateStmt *stmt, char relkind);
  
  extern void RemoveRelations(DropStmt *drop);
***************
*** 69,73 ****
--- 84,93 ----
  extern void AtEOSubXact_on_commit_actions(bool isCommit,
  							  SubTransactionId mySubid,
  							  SubTransactionId parentSubid);
+ 
+ extern void	DefinePartitions(CreateStmt *stmt, Oid parentRelId);
+ extern int GetPartitionsCount(Oid parentOid);
+ extern int GetPartitionsCountAtt(Oid parentOid, Oid attNum);
+ extern int ValidateRanges(PartitionAttrs *partAttr, Oid parentRelOid, Oid *partitionRelOids);
  
  #endif   /* TABLECMDS_H */
Index: src/include/nodes/execnodes.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/nodes/execnodes.h,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/include/nodes/execnodes.h	19 May 2009 06:59:38 -0000	1.1.1.3
--- src/include/nodes/execnodes.h	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 355,360 ****
--- 355,364 ----
  	TupleTable	es_tupleTable;	/* Array of TupleTableSlots */
  
  	uint32		es_processed;	/* # of tuples processed */
+ 
+ 	/* # of tuples that could not find valid partition and have been inserted into overflow partition. */
+ 	uint32		es_partition_overflow_tuples;	
+ 
  	Oid			es_lastoid;		/* last oid processed (by INSERT) */
  	List	   *es_rowMarks;	/* not good place, but there is no other */
  
Index: src/include/nodes/nodes.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/nodes/nodes.h,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/include/nodes/nodes.h	19 May 2009 06:59:38 -0000	1.1.1.3
--- src/include/nodes/nodes.h	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 376,382 ****
  	T_XmlSerialize,
  	T_WithClause,
  	T_CommonTableExpr,
! 
  	/*
  	 * TAGS FOR RANDOM OTHER STUFF
  	 *
--- 376,388 ----
  	T_XmlSerialize,
  	T_WithClause,
  	T_CommonTableExpr,
! 	T_PartitionAttrs,
! 	T_Partition,
! 	T_UpdatePartitionStmt,
! 	T_SplitPartitionStmt,
! 	T_MergePartitionStmt,
! 	T_ExchangePartitionStmt,
! 	T_RenamePartitionStmt,
  	/*
  	 * TAGS FOR RANDOM OTHER STUFF
  	 *
Index: src/include/nodes/parsenodes.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/nodes/parsenodes.h,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/include/nodes/parsenodes.h	19 May 2009 06:59:38 -0000	1.1.1.3
--- src/include/nodes/parsenodes.h	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 1131,1137 ****
  	AT_EnableReplicaRule,		/* ENABLE REPLICA RULE name */
  	AT_DisableRule,				/* DISABLE RULE name */
  	AT_AddInherit,				/* INHERIT parent */
! 	AT_DropInherit				/* NO INHERIT parent */
  } AlterTableType;
  
  typedef struct AlterTableCmd	/* one subcommand of an ALTER TABLE */
--- 1131,1146 ----
  	AT_EnableReplicaRule,		/* ENABLE REPLICA RULE name */
  	AT_DisableRule,				/* DISABLE RULE name */
  	AT_AddInherit,				/* INHERIT parent */
! 	AT_DropInherit,				/* NO INHERIT parent */
! 	AT_AddPartition,			/* add partition */
! 	AT_DropPartitionByName,		/* drop partition by name. */
! 	AT_DropPartitionByRange,	/* drop partition by range. */
! 	AT_UpdatePartition,			/* Update the range partition. */
! 	AT_SplitPartition,			/* Split range partition. */
! 	AT_MergePartition,			/* Merge range partitions. */
! 	AT_UpdateHashPartition,  	/* Update the hash partition. */
! 	AT_ExchangePartition,		/* Exchange partition with a table. */
! 	AT_RenamePartition			/* Rename a partition. */
  } AlterTableType;
  
  typedef struct AlterTableCmd	/* one subcommand of an ALTER TABLE */
***************
*** 1334,1339 ****
--- 1343,1349 ----
  	List	   *options;		/* options from WITH clause */
  	OnCommitAction oncommit;	/* what do we do at COMMIT? */
  	char	   *tablespacename; /* table space to use, or NULL */
+ 	Node	   *partAttr;		/* partitioning related information */
  } CreateStmt;
  
  /* ----------
***************
*** 1372,1389 ****
  	CONSTR_ATTR_IMMEDIATE
  } ConstrType;
  
  typedef struct Constraint
  {
! 	NodeTag		type;
! 	ConstrType	contype;
! 	char	   *name;			/* name, or NULL if unnamed */
! 	Node	   *raw_expr;		/* expr, as untransformed parse tree */
! 	char	   *cooked_expr;	/* expr, as nodeToString representation */
! 	List	   *keys;			/* String nodes naming referenced column(s) */
! 	List	   *options;		/* options from WITH clause */
! 	char	   *indexspace;		/* index tablespace for PKEY/UNIQUE
! 								 * constraints; NULL for default */
  } Constraint;
  
  /* ----------
   * Definitions for FOREIGN KEY constraints in CreateStmt
--- 1382,1479 ----
  	CONSTR_ATTR_IMMEDIATE
  } ConstrType;
  
+ 
+ /*
+  * Enumeration which defines the various possibilites for the partitioning
+  * function.
+  */
+ typedef enum PartitionFunction {
+         PART_UNDEFINED,
+         PART_LIST,
+         PART_RANGE,
+         PART_HASH
+ } PartitionFunction;
+ 
+ 
  typedef struct Constraint
  {
! 	NodeTag				type;
! 	List 				*min_value;
! 	List				*max_value;
! 	List				*partition_list_values;
! //	ConstrType			contype;
! 	PartitionFunction	contype;
! 	char	   			*name;			/* name, or NULL if unnamed */
! 	Node	   			*raw_expr;		/* expr, as untransformed parse tree */
! 	char	   			*cooked_expr;	/* expr, as nodeToString representation */
! 	List	   			*keys;			/* String nodes naming referenced column(s) */
! 	List	   			*options;		/* options from WITH clause */
! 	char	   			*indexspace;	/* index tablespace for PKEY/UNIQUE
! 								 			* constraints; NULL for default */
  } Constraint;
+ 
+ //typedef struct PartitionConstraint
+ //{
+ //	Node			*min_value;
+ //  	Node			*max_value;
+ //	List 			*list_partition_values;
+ //	PartitionFunction 	contype;
+ //	char	   		*name;			/* name, or NULL if unnamed */
+ //	Node	   		*raw_expr;		/* expr, as untransformed parse tree */
+ //	char	   		*cooked_expr;		/* expr, as nodeToString representation */
+ //	List	   		*keys;			/* String nodes naming referenced column(s) */
+ //	List	   		*options;		/* options from WITH clause */
+ //	char	   		*indexspace;		/* index tablespace for PKEY/UNIQUE
+ //								 * constraints; NULL for default */
+ // } PartitionConstraint;
+ 
+ typedef struct Partition {
+ 	NodeTag		type;
+ 	RangeVar	*partName;          /* Name of the partition */
+ 	Constraint	*partitionCheck;    /* per partition constraint */
+ 	char 		*tablespacename;	/* tablespace name*/ 
+ } Partition;
+ 
+ typedef struct UpdatePartitionStmt
+ {
+ 	NodeTag		type;
+ 	Partition 	*prev;
+ 	Partition 	*after;
+ }UpdatePartitionStmt;
+ 
+ typedef struct SplitPartitionStmt
+ {
+ 	NodeTag 	type;
+ 	List		*partNames;
+ 	List		*splitValues;
+ }SplitPartitionStmt;
+ 
+ typedef struct MergePartitionStmt
+ {
+ 	NodeTag 	type;
+ 	List		*partNames;
+ }MergePartitionStmt;
+ 
+ typedef struct ExchangePartitionStmt
+ {
+ 	NodeTag 	type;
+ 	List		*partNames;
+ }ExchangePartitionStmt;
+ 
+ typedef struct RenamePartitionStmt
+ {
+ 	NodeTag 	type;
+ 	List		*partNames;
+ }RenamePartitionStmt;
+ 
+ typedef struct PartitionAttrs {
+ 	NodeTag				type;
+ 	int     			numberOfPartitions; /* Number of partitions */
+ 	List    			*partitions;  		/* The list of partitions */
+ 	PartitionFunction 	partFunc; 			/* type of partition */
+ 	List 				*colName;           /* partition column name */
+ 	bool				hasOverflowPartition;
+ } PartitionAttrs;
  
  /* ----------
   * Definitions for FOREIGN KEY constraints in CreateStmt
Index: src/include/parser/kwlist.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/parser/kwlist.h,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.2.1
diff -c -r1.1.1.1 -r1.1.1.1.2.1
*** src/include/parser/kwlist.h	19 May 2009 06:59:38 -0000	1.1.1.1
--- src/include/parser/kwlist.h	26 May 2009 08:04:45 -0000	1.1.1.1.2.1
***************
*** 142,147 ****
--- 142,148 ----
  PG_KEYWORD("enum", ENUM_P, UNRESERVED_KEYWORD)
  PG_KEYWORD("escape", ESCAPE, UNRESERVED_KEYWORD)
  PG_KEYWORD("except", EXCEPT, RESERVED_KEYWORD)
+ PG_KEYWORD("exchange", EXCHANGE, UNRESERVED_KEYWORD)
  PG_KEYWORD("excluding", EXCLUDING, UNRESERVED_KEYWORD)
  PG_KEYWORD("exclusive", EXCLUSIVE, UNRESERVED_KEYWORD)
  PG_KEYWORD("execute", EXECUTE, UNRESERVED_KEYWORD)
***************
*** 227,232 ****
--- 228,234 ----
  PG_KEYWORD("mapping", MAPPING, UNRESERVED_KEYWORD)
  PG_KEYWORD("match", MATCH, UNRESERVED_KEYWORD)
  PG_KEYWORD("maxvalue", MAXVALUE, UNRESERVED_KEYWORD)
+ PG_KEYWORD("merge", MERGE, UNRESERVED_KEYWORD)
  PG_KEYWORD("minute", MINUTE_P, UNRESERVED_KEYWORD)
  PG_KEYWORD("minvalue", MINVALUE, UNRESERVED_KEYWORD)
  PG_KEYWORD("mode", MODE, UNRESERVED_KEYWORD)
***************
*** 278,284 ****
  PG_KEYWORD("owner", OWNER, UNRESERVED_KEYWORD)
  PG_KEYWORD("parser", PARSER, UNRESERVED_KEYWORD)
  PG_KEYWORD("partial", PARTIAL, UNRESERVED_KEYWORD)
! PG_KEYWORD("partition", PARTITION, UNRESERVED_KEYWORD)
  PG_KEYWORD("password", PASSWORD, UNRESERVED_KEYWORD)
  PG_KEYWORD("placing", PLACING, RESERVED_KEYWORD)
  PG_KEYWORD("plans", PLANS, UNRESERVED_KEYWORD)
--- 280,287 ----
  PG_KEYWORD("owner", OWNER, UNRESERVED_KEYWORD)
  PG_KEYWORD("parser", PARSER, UNRESERVED_KEYWORD)
  PG_KEYWORD("partial", PARTIAL, UNRESERVED_KEYWORD)
! PG_KEYWORD("partition", PARTITION, RESERVED_KEYWORD)
! PG_KEYWORD("partitions", PARTITIONS, UNRESERVED_KEYWORD)
  PG_KEYWORD("password", PASSWORD, UNRESERVED_KEYWORD)
  PG_KEYWORD("placing", PLACING, RESERVED_KEYWORD)
  PG_KEYWORD("plans", PLANS, UNRESERVED_KEYWORD)
***************
*** 294,300 ****
  PG_KEYWORD("procedural", PROCEDURAL, UNRESERVED_KEYWORD)
  PG_KEYWORD("procedure", PROCEDURE, UNRESERVED_KEYWORD)
  PG_KEYWORD("quote", QUOTE, UNRESERVED_KEYWORD)
! PG_KEYWORD("range", RANGE, UNRESERVED_KEYWORD)
  PG_KEYWORD("read", READ, UNRESERVED_KEYWORD)
  PG_KEYWORD("real", REAL, COL_NAME_KEYWORD)
  PG_KEYWORD("reassign", REASSIGN, UNRESERVED_KEYWORD)
--- 297,303 ----
  PG_KEYWORD("procedural", PROCEDURAL, UNRESERVED_KEYWORD)
  PG_KEYWORD("procedure", PROCEDURE, UNRESERVED_KEYWORD)
  PG_KEYWORD("quote", QUOTE, UNRESERVED_KEYWORD)
! PG_KEYWORD("range", RANGE, RESERVED_KEYWORD)
  PG_KEYWORD("read", READ, UNRESERVED_KEYWORD)
  PG_KEYWORD("real", REAL, COL_NAME_KEYWORD)
  PG_KEYWORD("reassign", REASSIGN, UNRESERVED_KEYWORD)
***************
*** 340,345 ****
--- 343,349 ----
  PG_KEYWORD("simple", SIMPLE, UNRESERVED_KEYWORD)
  PG_KEYWORD("smallint", SMALLINT, COL_NAME_KEYWORD)
  PG_KEYWORD("some", SOME, RESERVED_KEYWORD)
+ PG_KEYWORD("split", SPLIT, UNRESERVED_KEYWORD)
  PG_KEYWORD("stable", STABLE, UNRESERVED_KEYWORD)
  PG_KEYWORD("standalone", STANDALONE_P, UNRESERVED_KEYWORD)
  PG_KEYWORD("start", START, UNRESERVED_KEYWORD)
Index: src/include/tcop/dest.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/tcop/dest.h,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/include/tcop/dest.h	19 May 2009 06:59:38 -0000	1.1.1.3
--- src/include/tcop/dest.h	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 71,77 ****
  
  
  /* buffer size to use for command completion tags */
! #define COMPLETION_TAG_BUFSIZE	64
  
  
  /* ----------------
--- 71,77 ----
  
  
  /* buffer size to use for command completion tags */
! #define COMPLETION_TAG_BUFSIZE 128 
  
  
  /* ----------------
Index: src/include/utils/builtins.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/utils/builtins.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/include/utils/builtins.h	19 May 2009 06:59:38 -0000	1.1.1.2
--- src/include/utils/builtins.h	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 16,21 ****
--- 16,23 ----
  
  #include "fmgr.h"
  #include "nodes/parsenodes.h"
+ #include "nodes/primnodes.h"
+ #include "lib/stringinfo.h"
  
  /*
   *		Defined in adt/
***************
*** 595,600 ****
--- 597,604 ----
  extern const char *quote_identifier(const char *ident);
  extern char *quote_qualified_identifier(const char *namespace,
  						   const char *ident);
+ extern char *pg_get_expr_text(RangeVar *relation, 
+ 						Node *raw_expr, StringInfo buf);
  
  /* tid.c */
  extern Datum tidin(PG_FUNCTION_ARGS);
Index: src/interfaces/libpq/libpq-int.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/interfaces/libpq/libpq-int.h,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/interfaces/libpq/libpq-int.h	19 May 2009 06:59:40 -0000	1.1.1.3
--- src/interfaces/libpq/libpq-int.h	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 81,87 ****
  /*
   * POSTGRES backend dependent Constants.
   */
! #define CMDSTATUS_LEN 64		/* should match COMPLETION_TAG_BUFSIZE */
  
  /*
   * PGresult and the subsidiary types PGresAttDesc, PGresAttValue
--- 81,87 ----
  /*
   * POSTGRES backend dependent Constants.
   */
! #define CMDSTATUS_LEN 128 /* should match COMPLETION_TAG_BUFSIZE */
  
  /*
   * PGresult and the subsidiary types PGresAttDesc, PGresAttValue
